﻿//テーブルを上下に分割するスクリプトです（ver.0405b）。
//上部の行もしくはセルを選択した状態でスタートします。
//選択した一番下の行までが分割後に上側テーブルになります。
//（一番上の行は選択されていなくても問題ありません。）
//ヘッダやフッタがあっても処理可能です。

var sel = app.activeDocument.selection[0];  //選択された行もしくはセル
var myTable = sel.parent ;  //作業対象のテーブル
var myTexrFrame = myTable.parent ;  //myTableが存在するテキストフレーム
var myStory = myTexrFrame.parentStory ; //myTableが含まれるストーリー

var myTableIndex = myTable.index ;   //ストーリーで何番目のテーブルか（0から）
var lastRowIndex = sel.cells[-1].parentRow.index ;  //選択している最終セルは何行目にあるか（ヘッダを含む）
var myTableRowLength = myTable.rows.length ;   //テーブルの行数（ヘッダとフッタを含む）
var myHeaderRowCount = sel.parent.headerRowCount ;  //ヘッダの行数
var myFooterRowCount = sel.parent.footerRowCount ;  //フッタの行数
var myInsertionPoint = myTable.storyOffset.index ;  //挿入点のindex

//段落を選択する
app.select(myStory.insertionPoints[myInsertionPoint]); 
app.select(myStory.insertionPoints[myInsertionPoint+1],SelectionOptions.addTo); 
app.select(myStory.insertionPoints[myInsertionPoint+2],SelectionOptions.addTo); 

//段落を複製する
var newSel = app.activeDocument.selection[0]; 
newSel = newSel.duplicate(LocationOptions.AFTER , newSel);

var tableA = myStory.tables[myTableIndex] ; //前のテーブル（元からあるもの）
var tableB = myStory.tables[myTableIndex+1] ;   //後のテーブル（複製したもの）

//tableAの後半行を削除
for( i = myTableRowLength - myFooterRowCount-1 ; i >= lastRowIndex + 1 ; i-- ){
    tableA.rows[i].remove();
    }

//tableBの前半行を削除
for( j = lastRowIndex ; j >= 0 + myHeaderRowCount ; j-- ){
    tableB.rows[j].remove();
    }